import dbus
import dbus.service
from dbus.mainloop.glib import DBusGMainLoop
from gi.repository import GLib

# Define a UUID for your service
SERVICE_UUID = '00001801-0000-1000-8000-00805f9b34fb'

class BLEService(dbus.service.Object):
    def __init__(self, bus, index):
        self.path = f"/org/bluez/example/service{index}"
        self.props = {
            'UUID': dbus.String(SERVICE_UUID),
            'Primary': dbus.Boolean(True),
        }
        super().__init__(bus, self.path)

    @dbus.service.method('org.bluez.GattService1', in_signature='', out_signature='a{sv}')
    def GetProperties(self):
        return self.props

    @dbus.service.method('org.bluez.GattService1', in_signature='', out_signature='')
    def Release(self):
        print(f"{self.path}: Released")

def main():
    DBusGMainLoop(set_as_default=True)
    bus = dbus.SystemBus()

    service = MyBLEService(bus, 0)

    print("BLE Service running. Press Ctrl+C to stop.")
    mainloop = GLib.MainLoop()
    mainloop.run()

if __name__ == '__main__':
    main()
